#include <wcplugin.h>
#include <string.h>

#define	CALL_POINT	0x6006

void	wcWaitForFrame()__naked{
__asm;
	ei
	halt
	ret
__endasm;
}

void wcPRWOW(wcWindow* win)__naked{
	win;
__asm;
	push	ix
	ld	hl,#4
	add	hl,sp
	;
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	;
	push	de
	pop	ix
	ld	a,#1
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void	wcPrint(wcWindow* win, const char* text, uint8_t x, uint8_t y, uint8_t color){
	wcPRSRW(win, text, x, y, strlen(text), color);
}

void wcPRSRW(wcWindow* win, const char* text, uint8_t x, uint8_t y, uint16_t len, uint8_t color)__naked{
	win;text;x;y;len;color;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	; text
	ld	l,2(ix)
	ld	h,3(ix)
	; x y
	ld	e,4(ix)
	ld	d,5(ix)
	; len
	ld	c,6(ix)
	ld	b,7(ix)
	; win
	exx
	ld	c,0(ix)
	ld	b,1(ix)
	; color
	ld	a,8(ix)
	push	af
	push	bc
	exx
	pop	ix
	ld	a,#3
	call	CALL_POINT
	pop	af
	ex	af,af' ; '
	;
	ld	a,#4
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void wcINTPL(uint8_t mode, void* int_handler)__naked{
	mode;int_handler;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	
	ld	a,(ix)
	ex	af,af' ; '
	
	ld	l,1(ix)
	ld	h,2(ix)
	
	ld	a,#86
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void	wcMNGCPL(uint8_t page)__naked{
	page;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;
	ld	a,(ix)
	ex	af,af' ; '
	;
	xor	a
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void	wcMNG0PL(uint8_t page)__naked{
	page;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;
	ld	a,(ix)
	ex	af,af' ; '
	;
	ld	a,#78
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void	wcMNG8PL(uint8_t page)__naked{
	page;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;
	ld	a,(ix)
	ex	af,af' ; '
	;
	ld	a,#79
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void	wcRRESB(wcWindow* win)__naked{
	win;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;
	ld	e,0(ix)
	ld	d,1(ix)
	;
	push	de
	pop	ix
	ld	a,#2
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

void*	wcGADRW(wcWindow* wnd, uint8_t x, uint8_t y)__naked{
	wnd;x;y;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;// whd
	ld	l,0(ix)
	ld	h,1(ix)
	;// x,y
	ld	e,2(ix)
	ld	d,3(ix)
	;
	push	hl
	pop	ix
	ld	a,#5
	call	CALL_POINT
	;// HL= return adress
	pop	ix
	ret
__endasm;
}

// 6	печать курсора
void	wcCURSHOW(wcWindow* wnd)__naked{
	wnd;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	ld	e,0(ix)
	ld	d,1(ix)
	push	de
	pop	ix
	ld	a,#6
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

// 7	стирание курсора (восстановление цвета)
void	wcCURHIDE(wcWindow* wnd)__naked{
	wnd;
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	ld	e,0(ix)
	ld	d,1(ix)
	push	de
	pop	ix
	ld	a,#7
	call	CALL_POINT
	pop	ix
	ret
__endasm;
}

uint8_t	wcYNMENU(uint8_t mode)__naked{
__asm;
	push	ix
	ld	ix,#0004
	add	ix,sp
	;
	ld	a,(ix)
	ex	af,af' ; '
	;
	ld	a,#8
	call	CALL_POINT
	ld	l,#1
	pop	ix
	;// if Z return 1 (OK)
	ret	z
	;// if NZ return 0 (CANCEL)
	ld	l,#0
	ret
__endasm;
}
